package weka.clusterers.FOptics;

import java.io.Serializable;

/* 
Copyright (C) 2014
Johannes Schneider, ABB Research,Switzerland, johannes.schneider@alumni.ethz.ch
(Most work conducted while non-affilated)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Utils class for Vector operations for getting distances, sorting and searching
 * 
 * @author Johannes Schneider
 */
public class  VectorOps implements Serializable {

private static final long serialVersionUID = 1L;


/**
* Compute distance of two vectors
* 
* @param Vector1 
* @param Vector2
*/
public static  float getDist(float[] vecPt1,float[] vecPt2)
{

	 //jaccard distance
	
	  /* int interab=0; 
	   int aunionb=0;
	   for (int j=0;j<di;j++)
	   {			   
		   if (vecPt1[j]>0 || vecPt2[j]>0)
		   {
			   aunionb++;
			   if (vecPt1[j]==vecPt2[j])
				   interab++;
		   }
	   }
	  float dist = 0;
	  if (aunionb>0)
		  dist=1-interab*1f/aunionb;*/
	
		
	    //Euclidean Distance	  
		float dist = 0;	
		int len = vecPt1.length;
		for(int j=0;j<len;j++)
		{
			dist+=(vecPt1[j]-vecPt2[j])*(vecPt1[j]-vecPt2[j]);	    		
		}
		dist = (float) Math.sqrt(dist);
		
		return dist;
	}

/**
* Sort data (and indexes) between a low and high bound using quicksort 
* Permutes data
* Modified source, taken from http://www.codeproject.com/Articles/23196/Iterative-Quick-Sort; this project is licensed under Code Project Open License (CPOL)
* Changes to original source -- removed bAscent parameter, added parameter for sorting indexes with data
* 
* @param data (used for sorting)
* @param index (permuted as data)
* @param nFirst between 0 and the upper bound of the array. 
* @param nLast between 0 and the upper bound of the array; must be guaranteed >= nFirst.
*/
public static void quicksort(float[] nData, int[] index, int nFirst, int nLast)
      {
              int i, j, nStkPtr = 0;
              float nTmp; int iTmp;
              boolean bSortCompleted = false, bDirection = true;

              // get the maximum size of stack required:
              int nStackMax = (int)((nLast + 3) * 2); // from Knuth Vol 3.
              // Note, +3 is added because: 
              // +1 to round up rather than down, 
              // +1 because it's a full bottom-up stack (ie Stack[0] is never used),
              // +1 because data array is zero-indexed.

              int[][] nStack = new int[nStackMax][2];

              do
              {
                  do
                  {
                      i = nFirst;
                      j = nLast;
                      bDirection = true;

                      do
                      {
                          if ((nData[i] > nData[j]))// == bAscend)
                          {
                              // Swap the two items in the list pointed to by i and j
                              nTmp = nData[i];
                              nData[i] = nData[j];
                              nData[j] = nTmp;
                              iTmp = index[i];
                              index[i] = index[j];
                              index[j] = iTmp;
                              bDirection = !bDirection;
                          }

                          if (bDirection)
                              j--;
                          else
                              i++;

                      }
                      while (i < j);

                      if (i + 1 < nLast)
                      {
                          // There's another partition to be sorted
                          nStkPtr++;
                          nStack[nStkPtr][0] = i + 1;
                          nStack[nStkPtr][1] = nLast;
                      }
                      nLast = i - 1;

                  }
                  while (nFirst < nLast);

                  if (nStkPtr == 0)
                  {
                      // No more partitions to sort, so by definition we've finished!
                      bSortCompleted = true;
                  }

                  else
                  {
                      // Pop the most recently stored partition and sort that
                      nFirst = nStack[nStkPtr][ 0];
                      nLast = nStack[nStkPtr][ 1];
                      nStkPtr--;
                  }
              } while (!bSortCompleted);
      }
     
     
/**
* Binary Search
* @param data to serch in
* @param data item to find
* @param lower index in array to search 
* @param upper index in array to search 
*/
 public static int bsearch( float[ ] array, float rs, int low, int high ) {
		int middle = 0;
		while( low < high-1 ) {
			middle = ( low + high ) >>> 1; 
			if( array[ middle ] > rs ) {
				high = middle - 1;
			} else if( array[ middle ] < rs ) {
				low = middle + 1;}
			else if( array[ middle ] == rs )
				break;				
		}	
		if( array[ middle ] < rs )
			middle++;
		return middle;
	}
}
